leetcode39-回溯组合求和

给定一个无重复元素的数组 candidates 和一个目标数 target ,找出 candidates 中所有可以使数字和为 target 的组合。candidates 中的数字可以无限制重复被选取。

说明

  • 所有数字(包括 target)都是正整数。
  • 解集不能包含重复的组合。

方法一:搜索回溯
我们定义递归函数 dfs(target, combine, idx) 表示当前在 candidates 数组的第 idx 位,还剩 target 要组合,已经组合的列表为 combine。递归的终止条件为 target <= 0 或者 candidates 数组被全部用完。那么在当前的函数中,每次我们可以选择跳过不用第 idx 个数,即执行 dfs(target, combine, idx + 1)。也可以选择使用第 idx 个数,即执行 dfs(target - candidates[idx], combine, idx),注意到每个数字可以被无限制重复选取,因此搜索的下标仍为 idx。

更形象化地说,如果我们将整个搜索过程用一个树来表达,即如下图呈现,每次的搜索都会延伸出两个分叉,直到递归的终止条件,这样我们就能不重复且不遗漏地找到所有可行解:

在这里插入图片描述

class Solution {
    public List<List<Integer>> combinationSum(int[] candidates, int target) {
        List<List<Integer>> ans = new ArrayList<List<Integer>>();//二维数组用来存储最终得到的结果,即多个结果
        List<Integer> combine = new ArrayList<Integer>();//combine 用来存储符合条件的结果
        dfs(candidates, target, ans, combine, 0);
        return ans;
    }

    public void dfs(int[] candidates, int target, List<List<Integer>> ans, List<Integer> combine, int idx) {
        if (idx == candidates.length) {
            return;//当传入的idx值为数组最后一个元素时,结束
        }
        if (target == 0) {
            ans.add(new ArrayList<Integer>(combine));//当target==0时即找到了一组数combine符合要求
            return;
        }
        // 直接跳过
        dfs(candidates, target, ans, combine, idx + 1);//这里可以选择不用idx这个数
        // 选择当前数
        if (target - candidates[idx] >= 0) {//当target减去idx值不小于0时继续进行递归
            combine.add(candidates[idx]);//讲idx存入combine数组中
            dfs(candidates, target - candidates[idx], ans, combine, idx);//继续递归
            combine.remove(combine.size() - 1);//不管最后combine是否符合 要求都要去除数组中最后一个值来保证能继续寻找下一个数填入combine中使combine符合要求,如果当target - candidates[idx]>=0时一直
无法找到符合要求的数组时,一直移除combine最后一个数字,知道combine为空        }
    }
}

方法二:搜索回溯+剪枝
在这里插入图片描述
思路分析:根据示例 1:输入: candidates = [2, 3, 6, 7],target = 7。

  • 候选数组里有 2,如果找到了组合总和为 7 - 2 = 5 的所有组合,再在之前加上 2 ,就是 7 的所有组合;
  • 同理考虑 3,如果找到了组合总和为 7 - 3 = 4 的所有组合,再在之前加上 3 ,就是 7 的所有组合,依次这样找下去。
    剪枝操作即将其变成

在这里插入图片描述

public static List<List<Integer>> combinationSum(int []candidatates,int target){
        List<List<Integer>>ans=new ArrayList<List<Integer>>();
        List<Integer>path=new ArrayList<Integer>();

        int len=candidatates.length;
        if(len==0)
            return null;
        Arrays.sort(candidatates);//必须排序  是剪枝的前提
        dfs(candidatates,0,len,target,ans,path);
        return ans;
    }
    public static void dfs(int []candidatates,int begin,int len,int target,List<List<Integer>> ans,List<Integer>path){
        if(target<0)
            return;
        if(target==0){
            ans.add(new ArrayList<Integer>(path));
            return;
        }
        for(int i=begin;i<len;i++){//这里的循环就是用target依次减去数组中的值

            if(target-candidatates[i]<0)
                break;
            path.add(candidatates[i]);
            dfs(candidatates,i,len,target-candidatates[i],ans,path);
            path.remove(path.size()-1);
        }
    }

版权声明:本文为haha9417原创文章,遵循 CC 4.0 BY-SA 版权协议,转载请附上原文出处链接和本声明。
THE END
< <上一篇
下一篇>>